Module | ActiveSupport::CoreExtensions::Date::Conversions
In: | lib/active_support/core_ext/date/conversions.rb

Converting dates to formatted strings, times, and datetimes.

### Methods

readable_inspect to_date to_datetime to_formatted_s to_time xmlschema

### Constants

DATE_FORMATS | = | { :short => "%e %b", :long => "%B %e, %Y", :db => "%Y-%m-%d", :number => "%Y%m%d", :long_ordinal => lambda { |date| date.strftime("%B #{date.day.ordinalize}, %Y") }, # => "April 25th, 2007" :rfc822 => "%e %b %Y"

### Public Instance methods

readable_inspect()

Overrides the default inspect method with a human readable one, e.g., "Mon, 21 Feb 2005"

to_date()

A method to keep Time, Date and DateTime instances interchangeable on conversions. In this case, it simply returns `self`.

to_datetime()

Converts a Date instance to a DateTime, where the time is set to the beginning of the day and UTC offset is set to 0.

#### Examples

      date = Date.new(2007, 11, 10)  # => Sat, 10 Nov 2007

      date.to_datetime               # => Sat, 10 Nov 2007 00:00:00 0000

to_formatted_s(format = :default)

Convert to a formatted string. See DATE_FORMATS for predefined formats.

This method is aliased to `to_s`.

#### Examples

      date = Date.new(2007, 11, 10)       # => Sat, 10 Nov 2007

      date.to_formatted_s(:db)            # => "2007-11-10"
      date.to_s(:db)                      # => "2007-11-10"

      date.to_formatted_s(:short)         # => "10 Nov"
      date.to_formatted_s(:long)          # => "November 10, 2007"
      date.to_formatted_s(:long_ordinal)  # => "November 10th, 2007"
      date.to_formatted_s(:rfc822)        # => "10 Nov 2007"

## Adding your own time formats to to_formatted_s

You can add your own formats to the Date::DATE_FORMATS hash. Use the format name as the hash key and either a strftime string or Proc instance that takes a date argument as the value.

      # config/initializers/time_formats.rb
      Date::DATE_FORMATS[:month_and_year] = "%B %Y"
      Date::DATE_FORMATS[:short_ordinal] = lambda { |date| date.strftime("%B #{date.day.ordinalize}") }

to_time(form = :local)

Converts a Date instance to a Time, where the time is set to the beginning of the day. The timezone can be either :local or :utc (default :local).

#### Examples

      date = Date.new(2007, 11, 10)  # => Sat, 10 Nov 2007

      date.to_time                   # => Sat Nov 10 00:00:00 0800 2007
      date.to_time(:local)           # => Sat Nov 10 00:00:00 0800 2007

      date.to_time(:utc)             # => Sat Nov 10 00:00:00 UTC 2007

xmlschema()

[Validate]